;஭ 몫⥫  - ᠭ ⠫᪨ (2:450/195.234)
;蠥 ᢮ ࠭  䨪
;
;FUSES: BODLEVEL=1, BODEN=0, CKSEL=2, RSTDISBL=0, SPIEN=
;  0x12 (OSC_LDI)  OSCCAL  ᪮ ⠭ ஫ !
;
.nolist
.include "tn12def.inc"
.def	Timer	=R23
.def	PWM	=R26
.def	Level1	=R20
.def	Level2	=R21
.equ	INITTIMER=208
.equ	MINIM	=0x18
.equ	MAXIM	=0xA8
.list
.CSEG
	rjmp	RESET		; Reset Handle
	rjmp	INT0_F		; INT0 Handle
	reti
	rjmp	TIM0_OV		; Timer0 Overflow Handle
	reti
	reti

RESET:	wdr
	ldi	r16,(1<<WDE)+(0<<WDP2)+(1<<WDP1)+(1<<WDP0)
	out	WDTCR,r16	; WDT enable
OSC_LDI:ldi	r16,0x3F
	out	OSCCAL,r16	; Set OSC frequency
	ldi	r16,(1<<ACD)
	out	ACSR,r16	; Comparator OFF
	ldi	r16,0b00001101
	out	DDRB,r16	; PB0,PB2,PB3 as output
	out	PORTB,r16	; BTs, LED off
	ldi	r16,(1<<PUD)+(1<<ISC00)+(1<<ISC01)+(1<<SE)
	out	MCUCR,r16	; PullUp disable, INT0 by 0->1, Idle sleep
	ldi	r16,(1<<TOIE0)
	out	TIMSK,r16	; enable T/C0 interrupt
	ldi	r16,(1<<CS00)
	out	TCCR0,r16	; T/C0 input CK
	ldi	r16,(1<<INT0)
	out	GIMSK,r16	; enable INT0 interrupt
	ldi	Level1,MAXIM	; Initial power level
	ldi	Level2,MAXIM
	clr	PWM		; Reset PWM counter
	clr	Timer
	sei			; Enable interrupts
waitsync:
	wdr
	sleep
	ldi	r16,0b00001101
	out	DDRB,r16	; PB0,PB2,PB3 as output
	rjmp	waitsync
;--------------------------------------------------
TIM0_OV:ldi	r22,INITTIMER
	out	TCNT0,r22
	in	r0,SREG
	inc	Timer
	cpse	Level1,Level2	; Level1=Level2 ?
	rjmp	PWM1
	cpi	Level1,MAXIM	; yes
	brsh	LED_ON		; don't switch
	cpse	PWM,Level1
	rjmp	nopulse
	ldi	r19,0b00001000	; pulse to all BTs
	rjmp	BTout

PWM1:	cpi	Level1,MAXIM
	brsh	PWM2
	cpse	PWM,Level1	; time to switch ?
	rjmp	PWM2
	ldi	r19,0b00001001	; pulse
	rjmp	BTout

PWM2:	cpi	Level2,MAXIM
	brsh	nopulse
	cpse	PWM,Level2	; time to switch ?
	rjmp	nopulse
	ldi	r19,0b00001100	; pulse
BTout:	out	PORTB,r19
	nop			; delay
	nop
	nop
	nop
nopulse:ldi	r19,0b00001101	; no pulse
	out	PORTB,r19
	inc	PWM
	cp	PWM,r2
	brne	TIM0_EX
	clr	PWM
TIM0_EX:out	SREG,r0
	reti

LED_ON:	ldi	r19,0b00000101	; LED on, no pulse
	out	PORTB,r19
	out	SREG,r0
	reti
;------------------------------------------
INT0_F:	ldi	r22,INITTIMER
	out	TCNT0,r22
	in	r1,SREG
	mov	r2,Timer
	clr	Timer
	clr	PWM		; reset counter
	sec
	ror	r2		; 100Hz period
; Power control
	sbis	PINB,4
	rjmp	on1
	cpi	Level1,MAXIM	; Maximum ?
	brsh	power2
	inc	Level1		; No
	rjmp	power2

on1:	cpi	Level1,MINIM	; Minimum ?
	breq	power2
	brlo	on_1
	dec	Level1		; No
	rjmp	power2
on_1:	ldi	Level1,MINIM

power2:	sbis	PINB,5
	rjmp	on2
	cpi	Level2,MAXIM	; Maximum ?
	brsh	int0ex
	inc	Level2		; No
	out	SREG,r1
	reti

on2:	cpi	Level2,MINIM	; Minimum ?
	breq	int0ex
	brlo	on_2
	dec	Level2		; No
int0ex:	out	SREG,r1
	reti
on_2:	ldi	Level2,MINIM
	out	SREG,r1
	reti
